/* snxun.com */
(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('vue')) :
	typeof define === 'function' && define.amd ? define(['exports', 'vue'], factory) :
	(global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.VI = {}, global.Vue));
})(this, (function (exports, vue) { 'use strict';

	var Plugins = [];

	const colProns = {
	  span: {
	    type: Number,
	    default: 24
	  }
	};

	const isArray = (val) => Array.isArray(val);

	function createNamespace(name) {
	  const namespace = `vi-${name}`;
	  const getNameSpace = () => {
	    return namespace;
	  };
	  const getFullBlock = (className) => {
	    const reg = /[a-zA-Z\-]+(?=(\_\_[a-zA-Z])*)/g;
	    return className.match(reg);
	  };
	  const getFullElement = (className) => {
	    const reg = /(\_\_)[a-zA-z]+/g;
	    let firstRound = className.match(reg);
	    firstRound ? firstRound[0].replace(/^\_\_/g, "") : "";
	    return firstRound;
	  };
	  const getFullModifier = (className) => {
	    const reg = /(?=\_\_)(\_\_)[a-zA-z]+/g;
	    return className.match(reg);
	  };
	  const extendNameSpace = (suffix) => {
	    return `${namespace}-${suffix}`;
	  };
	  const getDepth = (text, parser) => {
	    return text.split(parser).length;
	  };
	  const createBEM = (suffix) => {
	    if (!suffix)
	      return namespace;
	    return suffix.startsWith("-") ? `${namespace}${suffix}` : `${namespace}_${suffix}`;
	  };
	  const classes = (...classes2) => {
	    return classes2.map((className) => {
	      if (isArray(className)) {
	        const [condition, truthy, falsy = null] = className;
	        return condition ? truthy : falsy;
	      }
	      return className;
	    });
	  };
	  return {
	    g: getNameSpace,
	    gb: getFullBlock,
	    ge: getFullElement,
	    gm: getFullModifier,
	    gd: getDepth,
	    e: extendNameSpace,
	    n: createBEM,
	    classes
	  };
	}

	var _export_sfc = (sfc, props) => {
	  const target = sfc.__vccOpts || sfc;
	  for (const [key, val] of props) {
	    target[key] = val;
	  }
	  return target;
	};

	const { n: n$3, classes: classes$8 } = createNamespace("col");
	const _sfc_main$1 = vue.defineComponent({
	  name: "VICol",
	  props: colProns,
	  setup() {
	    const space = vue.inject("gutter") || 24;
	    return {
	      n: n$3,
	      classes: classes$8,
	      space
	    };
	  }
	});
	function _sfc_render$1(_ctx, _cache, $props, $setup, $data, $options) {
	  return vue.openBlock(), vue.createElementBlock("div", {
	    class: vue.normalizeClass(_ctx.classes(_ctx.n(), "vi-box", _ctx.n(`-${_ctx.span}`))),
	    style: vue.normalizeStyle({
	      paddingRight: _ctx.space / 2 + "px",
	      paddingLeft: _ctx.space / 2 + "px",
	      paddingTop: _ctx.space / 2 + "px",
	      paddingBottom: _ctx.space / 2 + "px"
	    })
	  }, [
	    vue.createElementVNode("div", {
	      class: vue.normalizeClass(_ctx.classes(_ctx.n(`-child`)))
	    }, [
	      vue.renderSlot(_ctx.$slots, "default")
	    ], 2)
	  ], 6);
	}
	var Col = /* @__PURE__ */ _export_sfc(_sfc_main$1, [["render", _sfc_render$1], ["__file", "col.vue"]]);

	const withInstall = (comp, extra) => {
	  comp.install = function(app) {
	    const componentName = !extra ? "vi-" + comp.name.replace(/vi/gi, "").toLowerCase() : `vi-${extra}`;
	    app.component(componentName, comp);
	  };
	  return comp;
	};

	const VICol = withInstall(Col);

	const rowProns = {
	  gutter: {
	    type: [String, Number, Array],
	    default: 10
	  },
	  justify: {
	    type: String,
	    default: "flex-start"
	  },
	  align: {
	    type: String,
	    default: "flex-start"
	  }
	};

	const { n: n$2, classes: classes$7 } = createNamespace("row");
	const _sfc_main = vue.defineComponent({
	  name: "VIRow",
	  props: rowProns,
	  setup(props) {
	    const gutter = vue.ref(props.gutter);
	    vue.provide("gutter", gutter);
	    const styleComputed = vue.computed(() => {
	      return {
	        "align-items": props.align,
	        "justify-content": props.justify
	      };
	    });
	    return {
	      n: n$2,
	      classes: classes$7,
	      styleComputed
	    };
	  }
	});
	function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
	  return vue.openBlock(), vue.createElementBlock("div", {
	    class: vue.normalizeClass(_ctx.classes(_ctx.n(), "vi-box")),
	    style: vue.normalizeStyle(_ctx.styleComputed)
	  }, [
	    vue.renderSlot(_ctx.$slots, "default")
	  ], 6);
	}
	var Row = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render], ["__file", "row.vue"]]);

	const VIRow = withInstall(Row);

	var Components = [VICol, VIRow];

	const INSTALLED_KEY = Symbol("INSTALLED_KEY");
	const makeInstaller = (components = []) => {
	  const install = (app) => {
	    if (app[INSTALLED_KEY])
	      return;
	    app[INSTALLED_KEY] = true;
	    components.forEach((c) => app.use(c));
	  };
	  return {
	    install
	  };
	};

	var installer = makeInstaller([...Components, ...Plugins]);

	const calendarProps = {
	  scopeName: {
	    type: String,
	    require: false,
	    default: ""
	  },
	  hasFootBtns: {
	    type: Boolean,
	    require: false,
	    default: true
	  },
	  useTransition: {
	    type: Boolean,
	    require: false,
	    default: false
	  },
	  usePropTime: {
	    type: Boolean,
	    require: false,
	    default: false
	  },
	  year: {
	    type: Number,
	    require: false,
	    default: 1900
	  },
	  month: {
	    type: Number,
	    require: false,
	    default: 1
	  },
	  date: {
	    type: Number,
	    require: false,
	    default: 1
	  }
	};

	function getMonthDatesCount(year, month) {
	  const date = new Date(year, month, 0);
	  return date.getDate();
	}
	function getCurrentMonthDisplayDates(year, month) {
	  let dateCount = getMonthDatesCount(year, month);
	  let dates = [];
	  for (let i = 1; i <= dateCount; ++i) {
	    dates.push(String(i));
	  }
	  return dates;
	}
	function getLastMonthDisplayDates(year, month) {
	  const date = new Date(year, month - 1, 0);
	  let endDate = date.getDate();
	  let endDay = date.getDay();
	  let dates = [];
	  while (endDay >= 0) {
	    dates.push(String(endDate));
	    --endDate;
	    --endDay;
	  }
	  return dates.reverse();
	}
	function getNextMonthDisplayDates(year, month) {
	  let lastMonthDatesCount = getLastMonthDisplayDates(year, month).length;
	  let currentMonthDatesCount = getMonthDatesCount(year, month);
	  let nextMonthDatesCount = 42 - currentMonthDatesCount - lastMonthDatesCount;
	  let dates = [];
	  for (let i = 1; i <= nextMonthDatesCount; ++i) {
	    dates.push(String(i));
	  }
	  return dates;
	}
	function getDateInfo(timeStamp) {
	  let date = timeStamp ? new Date(timeStamp) : new Date();
	  return [
	    date.getFullYear(),
	    date.getMonth() + 1,
	    date.getDate(),
	    date.getHours(),
	    date.getMinutes(),
	    date.getSeconds()
	  ];
	}
	function validateYear(year) {
	  year = Number(year);
	  if (year > 1900 && year < 9999) {
	    return year;
	  } else if (year <= 1900) {
	    year = 1900;
	  } else if (year >= 9999) {
	    year = 9999;
	  } else {
	    alert("\u4E0D\u6B63\u786E\u7684\u65E5\u671F\u683C\u5F0F:\u5E74");
	  }
	  return year;
	}
	function validateMonth(month) {
	  month = Number(month);
	  if (month > 0 && month <= 12) {
	    return month;
	  } else if (month <= 0) {
	    month = 12 + month % 12;
	  } else if (month > 12) {
	    month = month % 12;
	  } else {
	    alert("\u4E0D\u6B63\u786E\u7684\u65E5\u671F\u683C\u5F0F:\u6708");
	  }
	  return month;
	}
	function validateTimeObject(timeObject, type) {
	  let keys = Object.keys(timeObject);
	  if (type == "date") {
	    keys = keys.filter((key) => {
	      return key == "year" || key == "month" || key == "date";
	    });
	  } else if (type == "time") {
	    keys = keys.filter((key) => {
	      return key == "hour" || key == "minute" || key == "second";
	    });
	  }
	  for (const key of keys) {
	    if (timeObject[key] == null) {
	      timeObject[key] = "00";
	    }
	  }
	  return timeObject;
	}
	function validateRangeResult(startTime, endTime, successCb, failCb) {
	  let startValidation = validateTimeObject(startTime);
	  let endValidation = validateTimeObject(endTime);
	  function createDateObject(timeObject) {
	    return new Date(
	      Number(timeObject["year"]),
	      Number(timeObject["month"] - 1),
	      Number(timeObject["date"]),
	      Number(timeObject["hour"]),
	      Number(timeObject["minute"]),
	      Number(timeObject["second"])
	    );
	  }
	  let start = createDateObject(startValidation);
	  let end = createDateObject(endValidation);
	  if (start < end) {
	    successCb();
	  } else if (start > end) {
	    alert(`\u5F00\u59CB\u65F6\u95F4\u4E0D\u80FD\u5927\u4E8E\u7ED3\u675F\u65F6\u95F4, \u8BF7\u91CD\u65B0\u9009\u62E9`);
	    failCb();
	  }
	}
	function getYearRange(year) {
	  year = Number(year);
	  let residue = year % 10;
	  let start = year - residue;
	  let end = start + 9;
	  return { start, end };
	}

	const {
	  g: g$8,
	  gb: gb$6,
	  ge: ge$6,
	  gm: gm$6,
	  e: e$9,
	  classes: classes$6
	} = createNamespace("calendar-time-picker");
	var ViTimePicker = vue.defineComponent({
	  name: "ViCalendarTimePicker",
	  props: {
	    active: {
	      type: Boolean,
	      require: true,
	      default: true
	    }
	  },
	  emits: ["fillTimeInput"],
	  setup(props, ctx) {
	    const lastSelectItem = {
	      hour: null,
	      minute: null,
	      second: null
	    };
	    let timeStore = vue.inject("store");
	    let showTimePanel = vue.inject("showTimePanel");
	    let showYearMonthPanel = vue.inject("showYearMonthPanel");
	    const togglePanel = () => {
	      showTimePanel.value = !showTimePanel.value;
	      showTimePanel.value ? showYearMonthPanel.value = false : "";
	    };
	    ctx.expose({
	      togglePanel
	    });
	    const lineHeight = 30;
	    const handleClick = (e2) => {
	      let tar = e2.target;
	      if (tar.className == "cancel") {
	        timeStore.hour = "00";
	        timeStore.minute = "00";
	        timeStore.second = "00";
	      }
	      showTimePanel.value = false;
	      ctx.emit("fillTimeInput", timeStore);
	    };
	    const handleMouseLeave = (e2) => {
	      let tar = e2.target;
	      let top = tar.scrollTop;
	      tar.scrollTop = Math.ceil(top / lineHeight) * lineHeight;
	    };
	    const handlePanelClick = (e2) => {
	      var _a, _b, _c, _d;
	      let tar = e2.target;
	      let index = Number(tar.innerText);
	      let top = index * lineHeight;
	      let scrollContainer = (_a = tar.parentNode) == null ? void 0 : _a.parentNode;
	      scrollContainer.scrollTop = top;
	      switch (tar.className) {
	        case "hour":
	          timeStore.hour = tar.innerText;
	          (_b = lastSelectItem.hour) == null ? void 0 : _b.classList.remove("active");
	          lastSelectItem.hour = tar;
	          break;
	        case "minute":
	          timeStore.minute = tar.innerText;
	          (_c = lastSelectItem.minute) == null ? void 0 : _c.classList.remove("active");
	          lastSelectItem.minute = tar;
	          break;
	        case "second":
	          timeStore.second = tar.innerText;
	          (_d = lastSelectItem.second) == null ? void 0 : _d.classList.remove("active");
	          lastSelectItem.second = tar;
	          break;
	      }
	      tar.classList.add("active");
	    };
	    const createLis = (count, type) => {
	      const lis = [];
	      for (let i = 0; i < count; ++i) {
	        lis.push(vue.createVNode("li", {
	          "class": type
	        }, [i < 10 ? "0" + i : i]));
	      }
	      return lis;
	    };
	    const hourLis = createLis(24, "hour");
	    const minuteLis = createLis(60, "minute");
	    const secondLis = createLis(60, "second");
	    return () => vue.createVNode(vue.Transition, {
	      "name": "scale"
	    }, {
	      default: () => [showTimePanel.value ? vue.createVNode("div", {
	        "class": classes$6(g$8())
	      }, [vue.createVNode("div", {
	        "class": classes$6("vi-time-picker__content"),
	        "onClick": handlePanelClick
	      }, [vue.createVNode("div", {
	        "class": classes$6("time-picker-container"),
	        "onMouseleave": handleMouseLeave
	      }, [vue.createVNode("ul", null, [...hourLis])]), vue.createVNode("div", {
	        "class": classes$6("time-picker-container"),
	        "onMouseleave": handleMouseLeave
	      }, [vue.createVNode("ul", null, [...minuteLis])]), vue.createVNode("div", {
	        "class": classes$6("time-picker-container"),
	        "onMouseleave": handleMouseLeave
	      }, [vue.createVNode("ul", null, [...secondLis])])]), vue.createVNode("div", {
	        "class": classes$6("vi-time-picker__footer")
	      }, [vue.createVNode("button", {
	        "class": classes$6("cancel"),
	        "onClick": handleClick
	      }, [vue.createTextVNode("\u53D6\u6D88")]), vue.createVNode("button", {
	        "class": classes$6("confirm"),
	        "onClick": handleClick
	      }, [vue.createTextVNode("\u786E\u5B9A")])])]) : ""]
	    });
	  }
	});

	const {
	  g: g$7,
	  gb: gb$5,
	  ge: ge$5,
	  gm: gm$5,
	  e: e$8,
	  classes: classes$5
	} = createNamespace("calendar");
	var ViCalendarHeader = vue.defineComponent({
	  name: "viCalendarHeader",
	  components: {
	    ViTimePicker
	  },
	  setup() {
	    const pickerProps = vue.reactive({});
	    let store = vue.inject("store");
	    const timePickerRef = vue.ref();
	    const onFillTimeInput = (e2) => {
	      let {
	        hour,
	        minute,
	        second
	      } = e2;
	      store.hour = hour;
	      store.minute = minute;
	      store.second = second;
	    };
	    const onTimeFocus = (e2) => {
	      timePickerRef.value.togglePanel();
	    };
	    return () => vue.createVNode("div", {
	      "class": classes$5(g$7() + "__header", "active")
	    }, [vue.createVNode("span", {
	      "class": classes$5("vi-header__input", "vi-header__input--date")
	    }, [vue.createVNode("input", {
	      "type": "text",
	      "autocomplete": "off",
	      "placeholder": "\u8BF7\u9009\u62E9\u65E5\u671F",
	      "value": `${store.year}-${store.month}-${store.date}`
	    }, null)]), vue.createVNode("span", {
	      "class": classes$5("vi-header__input", "vi-header__input--time")
	    }, [vue.createVNode("input", {
	      "type": "text",
	      "autocomplete": "off",
	      "placeholder": "\u8BF7\u9009\u62E9\u65F6\u95F4",
	      "value": `${store.hour}: ${store.minute}: ${store.second}`,
	      "onClick": onTimeFocus
	    }, null), vue.createVNode(vue.resolveComponent("vi-time-picker"), vue.mergeProps({
	      "ref": timePickerRef
	    }, pickerProps, {
	      "onFillTimeInput": onFillTimeInput
	    }), null)])]);
	  }
	});

	const {
	  g: g$6,
	  gb: gb$4,
	  ge: ge$4,
	  gm: gm$4,
	  e: e$7,
	  classes: classes$4
	} = createNamespace("year-month-picker");
	var ViYearMonthPicker = vue.defineComponent({
	  name: "ViCalendarYearMonthPicker",
	  setup(props, ctx) {
	    const monthText = ["\u4E00\u6708", "\u4E8C\u6708", "\u4E09\u6708", "\u56DB\u6708", "\u4E94\u6708", "\u516D\u6708", "\u4E03\u6708", "\u516B\u6708", "\u4E5D\u6708", "\u5341\u6708", "\u5341\u4E00\u6708", "\u5341\u4E8C\u6708"];
	    const trArray = [1, 2, 3];
	    const tdArray = [1, 2, 3, 4];
	    let store = vue.inject("store");
	    let showTimePanel = vue.inject("showTimePanel");
	    let showYearMonthPanel = vue.inject("showYearMonthPanel");
	    const {
	      start,
	      end
	    } = getYearRange(store.year);
	    const tbodyRef = vue.ref();
	    const yearRange = vue.reactive({
	      start,
	      end
	    });
	    const panelTitle = vue.ref(`${yearRange.start}-${yearRange.end}`);
	    const selectResult = vue.reactive({
	      year: store.year,
	      month: store.month
	    });
	    const updateYear = () => {
	      vue.nextTick(() => {
	        let tds = tbodyRef.value.querySelectorAll("td");
	        let [currentYear] = getDateInfo();
	        tds.forEach((td, tdi) => {
	          if (td.className.includes("current")) {
	            td.classList.remove("current");
	          }
	          let currentIndex = yearRange.start + tdi;
	          if (currentIndex == currentYear)
	            td.classList.add("current");
	          tdi < 10 ? td.innerText = String(currentIndex) : td.innerText = "";
	        });
	        panelTitle.value = `${yearRange.start}-${yearRange.end}`;
	      });
	    };
	    const updateMonth = () => {
	      vue.nextTick(() => {
	        tbodyRef.value.setAttribute("data-type", "month");
	        let tds = tbodyRef.value.querySelectorAll("td");
	        tds.forEach((td, tdi) => {
	          td.innerText = monthText[tdi];
	          if (td.className.includes("current")) {
	            td.classList.remove("current");
	          }
	        });
	      });
	      panelTitle.value = selectResult.year;
	    };
	    const togglePanel = (B) => {
	      showYearMonthPanel.value = B;
	      showYearMonthPanel.value ? showTimePanel.value = false : "";
	    };
	    ctx.expose({
	      togglePanel,
	      updateYear,
	      updateMonth
	    });
	    const handleYearSwitch = (e2) => {
	      let tar = e2.target;
	      let name = tar.className;
	      if (name.includes("arrow-btn")) {
	        if (name.includes("last")) {
	          yearRange.start -= 10;
	          yearRange.end -= 10;
	        }
	        if (name.includes("next")) {
	          yearRange.start += 10;
	          yearRange.end += 10;
	        }
	        updateYear();
	      }
	    };
	    const handleTableClick = (e2) => {
	      let tar = e2.target;
	      let type = tbodyRef.value.getAttribute("data-type");
	      if (type == "year") {
	        selectResult.year = tar.innerText;
	        panelTitle.value = tar.innerText;
	        updateMonth();
	      }
	      if (type == "month") {
	        let month = Number(tar.getAttribute("data-slot")) + 1;
	        selectResult.month = month < 10 ? "0" + month : String(month);
	        store.year = selectResult.year;
	        store.month = selectResult.month;
	        tbodyRef.value.setAttribute("data-type", "year");
	        showYearMonthPanel.value = false;
	      }
	    };
	    return () => vue.createVNode(vue.Transition, {
	      "name": "scale"
	    }, {
	      default: () => [showYearMonthPanel.value ? vue.createVNode("div", {
	        "class": classes$4(g$6())
	      }, [vue.createVNode("div", {
	        "class": classes$4("panel__header"),
	        "onClick": handleYearSwitch
	      }, [vue.createVNode("span", {
	        "class": classes$4("arrow-btn", "arrow-btn__last")
	      }, [vue.createTextVNode("<<")]), vue.createVNode("span", {
	        "class": classes$4("header-title")
	      }, [panelTitle.value]), vue.createVNode("span", {
	        "class": classes$4("arrow-btn", "arrow-btn__next")
	      }, [vue.createTextVNode(">>")])]), vue.createVNode("div", {
	        "class": classes$4("panel__content")
	      }, [vue.createVNode("table", {
	        "class": classes$4("content__table")
	      }, [vue.createVNode("tbody", {
	        "data-type": "year",
	        "ref": tbodyRef,
	        "onClick": handleTableClick
	      }, [trArray.map((tr, tri) => {
	        let tds = tdArray.map((td, tdi) => {
	          let index = tri * 4 + tdi;
	          let currentYear = start + index;
	          return vue.createVNode("td", {
	            "data-slot": index,
	            "class": classes$4([store.year == currentYear, "current", ""])
	          }, [index < 10 ? currentYear : ""]);
	        });
	        return vue.createVNode("tr", null, [tds]);
	      })])])])]) : ""]
	    });
	  }
	});

	const {
	  g: g$5,
	  gb: gb$3,
	  ge: ge$3,
	  gm: gm$3,
	  e: e$6,
	  classes: classes$3
	} = createNamespace("calendar");
	var ViCalendarContent = vue.defineComponent({
	  name: "ViCalendarContent",
	  components: {
	    ViYearMonthPicker
	  },
	  setup() {
	    const dayLabels = ["\u65E5", "\u4E00", "\u4E8C", "\u4E09", "\u56DB", "\u4E94", "\u516D"];
	    let currentDateEl = null;
	    let store = vue.inject("store");
	    const yearTitle = vue.ref();
	    const monthTitle = vue.ref();
	    const tBodyRef = vue.ref();
	    const titleRef = vue.ref();
	    const yearMonthPickerRef = vue.ref();
	    const lastSelectPage = {
	      year: "",
	      month: "",
	      date: ""
	    };
	    vue.watch(store, (newStore) => {
	      updateCalendar(newStore.year, newStore.month);
	      vue.nextTick(() => {
	        checkLastSelect(newStore);
	      });
	    });
	    const checkLastSelect = (store2) => {
	      if (store2.year == lastSelectPage.year && store2.month == lastSelectPage.month && store2.date == lastSelectPage.date) {
	        currentDateEl ? currentDateEl.classList.add("background--active") : "";
	      } else {
	        currentDateEl ? currentDateEl.classList.remove("background--active") : "";
	      }
	    };
	    const updateCalendar = (year, month) => {
	      let [currentYear, currentMonth, currentDate] = getDateInfo();
	      let lastMonthDisplays = getLastMonthDisplayDates(year, month);
	      let currentMonthDisplays = getCurrentMonthDisplayDates(year, month);
	      let nextMonthDisplays = getNextMonthDisplayDates(year, month);
	      let displays = [...lastMonthDisplays, ...currentMonthDisplays, ...nextMonthDisplays];
	      let titles = titleRef.value.children;
	      titles[0].innerText = store.year;
	      titles[1].innerText = store.month;
	      let trs = tBodyRef.value.querySelectorAll("tr");
	      trs.forEach((tr, row) => {
	        let tds = tr.querySelectorAll("td");
	        tds.forEach((td, col) => {
	          td.className = "vi-tr__td";
	          let statusClassName = "disable";
	          let currentIndex = row * 7 + col;
	          let start = lastMonthDisplays.length - 1;
	          let end = start + currentMonthDisplays.length;
	          if (currentIndex > start && currentIndex <= end) {
	            statusClassName = "available";
	          }
	          td.classList.add(statusClassName);
	          let background = td.querySelector("div");
	          if (background != currentDateEl) {
	            background ? background.className = "background" : "";
	          }
	          if (year == currentYear && month == currentMonth) {
	            let todayIndex = start + currentDate;
	            currentIndex == todayIndex ? background == null ? void 0 : background.classList.add("background--today") : "";
	          }
	          let span = background && background.querySelector("span");
	          span ? span.innerText = String(displays[currentIndex]) : "";
	        });
	      });
	    };
	    const handleTheadClick = (e2) => {
	      let {
	        year,
	        month
	      } = store;
	      let tar = e2.target;
	      if (tar.className.includes("arrow-btn")) {
	        if (tar.className.includes("gt")) {
	          let gtYear = validateYear(Number(year) + 1);
	          let gtMonth = validateMonth(Number(month) + 1);
	          if (tar.className.includes("year")) {
	            store.year = String(gtYear);
	            yearTitle.value.innerText = String(gtYear);
	          }
	          if (tar.className.includes("month")) {
	            store.month = String(gtMonth);
	            monthTitle.value.innerText = String(gtMonth);
	          }
	        } else {
	          let ltYear = validateYear(Number(year) - 1);
	          let ltMonth = validateMonth(Number(month) - 1);
	          if (tar.className.includes("year")) {
	            store.year = String(ltYear);
	            yearTitle.value.innerText = String(ltYear);
	          }
	          if (tar.className.includes("month")) {
	            store.month = String(ltMonth);
	            monthTitle.value.innerText = String(ltMonth);
	          }
	        }
	      } else if (tar.className.includes("title")) {
	        yearMonthPickerRef.value.togglePanel(true);
	        if (tar.className.includes("year")) {
	          yearMonthPickerRef.value.updateYear();
	        }
	        if (tar.className.includes("month")) {
	          yearMonthPickerRef.value.updateMonth();
	        }
	      }
	    };
	    const handleTbodyClick = (e2) => {
	      let background;
	      const tar = e2.target;
	      if (tar.className.includes("disable"))
	        return;
	      background = tar.childNodes[0];
	      background.classList.add("background--active");
	      if (currentDateEl) {
	        currentDateEl.classList.remove("background--active");
	      }
	      currentDateEl = background;
	      let span = background == null ? void 0 : background.childNodes[0];
	      let dateIndex = Number(span.innerText);
	      dateIndex < 10 ? store.date = "0" + dateIndex : store.date = String(dateIndex);
	      let {
	        year,
	        month,
	        date
	      } = store;
	      lastSelectPage.year = year;
	      lastSelectPage.month = month;
	      lastSelectPage.date = date;
	    };
	    const createTableBodyNodes = () => {
	      const tableNodes = [];
	      let [currentYear, currentMonth, currentDateEl2] = getDateInfo();
	      let lastMonthDisplays = getLastMonthDisplayDates(store.year, store.month);
	      let currentMonthDisplays = getCurrentMonthDisplayDates(store.year, store.month);
	      let nextMonthDisplays = getNextMonthDisplayDates(store.year, store.month);
	      let displays = [...lastMonthDisplays, ...currentMonthDisplays, ...nextMonthDisplays];
	      for (let row = 0; row < 6; ++row) {
	        let vtr = {
	          classList: ["vi-content__tr"],
	          children: []
	        };
	        for (let col = 0; col < 7; ++col) {
	          let currentIndex = row * 7 + col;
	          let start = lastMonthDisplays.length - 1;
	          let end = start + currentMonthDisplays.length;
	          let statusClassName = "disable";
	          if (currentIndex > start && currentIndex <= end) {
	            statusClassName = "available";
	          }
	          let isToday = false;
	          if (currentYear == store.year && currentMonth == store.month) {
	            let start2 = lastMonthDisplays.length;
	            let todayIndex = start2 + currentDateEl2 - 1;
	            currentIndex == todayIndex ? isToday = true : isToday = false;
	          }
	          vtr.children.push({
	            classList: ["vi-tr__td", statusClassName],
	            content: displays[currentIndex],
	            isToday
	          });
	        }
	        tableNodes.push(vtr);
	      }
	      return tableNodes;
	    };
	    return () => vue.createVNode("div", {
	      "class": classes$3(g$5() + "__content")
	    }, [vue.createVNode("div", {
	      "class": classes$3(e$6("content") + "__header"),
	      "onClick": handleTheadClick
	    }, [vue.createVNode("span", {
	      "class": classes$3("vi-content-header__lt", "arrow-btn", "year")
	    }, [vue.createTextVNode("<<")]), vue.createVNode("span", {
	      "class": classes$3("vi-content-header__lt", "arrow-btn", "month")
	    }, [vue.createTextVNode("<")]), vue.createVNode("span", {
	      "class": classes$3("title-wrapper"),
	      "ref": titleRef
	    }, [vue.createVNode("span", {
	      "class": "title__year",
	      "ref": yearTitle
	    }, [vue.createTextVNode(" "), store.year, vue.createTextVNode(" ")]), vue.createTextVNode("\u2002\u5E74\u2002"), vue.createVNode("span", {
	      "class": "title__month",
	      "ref": monthTitle
	    }, [vue.createTextVNode(" "), store.month, vue.createTextVNode(" ")]), vue.createTextVNode("\u2002\u6708\u2002")]), vue.createVNode("span", {
	      "class": classes$3("vi-content-header__gt--month", "arrow-btn", "month")
	    }, [vue.createTextVNode(">")]), vue.createVNode("span", {
	      "class": classes$3("vi-content-header__gt", "arrow-btn", "year")
	    }, [vue.createTextVNode(">>")]), vue.createVNode(vue.resolveComponent("vi-year-month-picker"), {
	      "ref": yearMonthPickerRef
	    }, null)]), vue.createVNode("div", {
	      "class": classes$3("vi-calender-content__table")
	    }, [vue.createVNode("table", null, [vue.createVNode("thead", null, [vue.createVNode("tr", null, [dayLabels.map((day) => {
	      return vue.createVNode("td", null, [day]);
	    })])]), vue.createVNode("tbody", {
	      "ref": tBodyRef,
	      "onClick": handleTbodyClick
	    }, [createTableBodyNodes().map((vtr) => {
	      let tds = vtr.children.map((vtd, ind) => {
	        return vue.createVNode("td", {
	          "class": vtd.classList
	        }, [vue.createVNode("div", {
	          "class": classes$3("background", [vtd.isToday, "background--today", ""])
	        }, [vue.createVNode("span", null, [vtd.content])])]);
	      });
	      return vue.createVNode("tr", {
	        "class": vtr.classList
	      }, [tds]);
	    })])])])]);
	  }
	});

	const {
	  g: g$4,
	  gb: gb$2,
	  ge: ge$2,
	  gm: gm$2,
	  e: e$5,
	  classes: classes$2
	} = createNamespace("calendar");
	var Calendar = vue.defineComponent({
	  name: "ViCalendar",
	  props: calendarProps,
	  components: {
	    ViCalendarHeader,
	    ViCalendarContent
	  },
	  setup(props, ctx) {
	    let [currentYear, currentMonth, currentDate] = getDateInfo();
	    const store = vue.shallowReactive({
	      year: `${currentYear}`,
	      month: `${currentMonth}`,
	      date: `${currentDate}`,
	      hour: "00",
	      minute: "00",
	      second: "00"
	    });
	    const getStore = () => {
	      return store;
	    };
	    const showTimePanel = vue.ref(false);
	    const showYearMonthPanel = vue.ref(false);
	    ctx.expose({
	      getStore
	    });
	    vue.provide("store", store);
	    vue.provide("showTimePanel", showTimePanel);
	    vue.provide("showYearMonthPanel", showYearMonthPanel);
	    return () => vue.createVNode("div", {
	      "class": classes$2(g$4())
	    }, [vue.createVNode(vue.resolveComponent("vi-calendar-header"), null, null), vue.createVNode(vue.resolveComponent("vi-calendar-content"), null, null)]);
	  }
	});

	const ViCalendar = withInstall(Calendar);

	const cssProperties = {
	  "--scale-x": "1",
	  "--scale-y": "1",
	  "--container-width": "300px",
	  "--container-height": "50px",
	  "--theme-color": "orange",
	  "--font-family": "monospace",
	  "--panel-offset-y": "55px",
	  "--border-radius": "10px",
	  "--background-color": "#fff",
	  "--panel-background-color": "transparent",
	  "--transition-name": "scale"
	};
	const functionProperties = {
	  "show-panel": false,
	  "svg-search": "./svg/iconmonstr-search-thin.svg",
	  "svg-clear": "./svg/iconmonstr-clear-thin.svg",
	  "confirm-callback": (store) => {
	    console.log("This is confirm callback, time is: ", store);
	  },
	  "cancel-callback": (store) => {
	    console.log("This is confirm callback, time is: ", store);
	  }
	};
	const props = {
	  functionProps: {
	    type: Object,
	    default: () => functionProperties
	  },
	  styleProps: {
	    type: Object,
	    default: () => cssProperties
	  }
	};

	const {
	  g: g$3,
	  gb: gb$1,
	  ge: ge$1,
	  gm: gm$1,
	  e: e$4,
	  classes: classes$1
	} = createNamespace("date-time-picker");
	var DateTimePicker = vue.defineComponent({
	  name: "Date-Time-Picker",
	  props,
	  components: {
	    ViCalendar
	  },
	  setup(props2, ctx) {
	    const rootRef = vue.ref();
	    const svgSearchRef = vue.ref();
	    const svgClearRef = vue.ref();
	    const showPanel = vue.ref(props2.functionProps["show-panel"]);
	    const inputName = g$3() + "__input";
	    const panelName = g$3() + "__panel";
	    const calendarProps = {
	      scopeName: "." + panelName,
	      useTransition: false,
	      hasFootBtns: true,
	      usePropTime: false
	    };
	    const calendarRef = vue.ref();
	    let fullTime = vue.ref("");
	    const handleConfirm = () => {
	      showPanel.value = !showPanel.value;
	      const store = calendarRef.value.getStore();
	      const {
	        year,
	        month,
	        date,
	        hour,
	        minute,
	        second
	      } = store;
	      fullTime.value = `${year}-${month}-${date}  ${hour}: ${minute}: ${second}`;
	      props2.functionProps["confirm-callback"](store);
	    };
	    const handleCancel = () => {
	      const [year, month, date, hour, minute, second] = getDateInfo();
	      let hourStr = hour < 10 ? "0" + hour : String(hour);
	      let minuteStr = minute < 10 ? "0" + hour : String(minute);
	      let secondStr = second < 10 ? "0" + hour : String(second);
	      const store = calendarRef.value.getStore();
	      store.year = `${year}`;
	      store.month = `${month}`;
	      store.date = `${date}`;
	      store.hour = hourStr;
	      store.minute = minuteStr;
	      store.second = secondStr;
	      fullTime.value = `${year}-${month}-${date}  ${hourStr}: ${minuteStr}: ${secondStr}`;
	      props2.functionProps["cancel-callback"](store);
	      showPanel.value = !showPanel.value;
	    };
	    const handleClear = () => {
	      fullTime.value = "";
	    };
	    const handleClick = (e2) => {
	      showPanel.value = !showPanel.value;
	    };
	    const applyProps = (props3) => {
	      vue.nextTick(() => {
	        let styles = props3.styleProps;
	        let others = props3.functionProps;
	        for (let key in styles) {
	          let value = styles[key];
	          rootRef.value.style.setProperty(key, value);
	        }
	        svgSearchRef.value.src = others["svg-search"];
	        svgClearRef.value.src = others["svg-clear"];
	        showPanel.value = others["show-panel"];
	      });
	    };
	    vue.watch(props2, (newValue) => {
	      applyProps(newValue);
	    }, {
	      deep: true,
	      immediate: true
	    });
	    return () => vue.createVNode("div", {
	      "class": classes$1(g$3()),
	      "ref": rootRef
	    }, [vue.createVNode("div", {
	      "class": classes$1(inputName)
	    }, [vue.createVNode("div", {
	      "class": classes$1("icon-container")
	    }, [vue.createVNode("img", {
	      "ref": svgSearchRef,
	      "width": "18",
	      "height": "18"
	    }, null), vue.createVNode("input", {
	      "type": "text",
	      "value": fullTime.value,
	      "onClick": handleClick
	    }, null), vue.createVNode("img", {
	      "ref": svgClearRef,
	      "width": "12",
	      "height": "12",
	      "onClick": handleClear
	    }, null)])]), showPanel.value ? vue.createVNode(vue.Transition, {
	      "name": "scale"
	    }, {
	      default: () => [vue.createVNode("div", {
	        "class": classes$1(panelName)
	      }, [vue.createVNode(vue.resolveComponent("vi-calendar"), vue.mergeProps(calendarProps, {
	        "ref": calendarRef
	      }), null), vue.createVNode("div", {
	        "class": classes$1("vi-panel__footer")
	      }, [vue.createVNode("div", {
	        "class": classes$1("footer__btn-container")
	      }, [vue.createVNode("button", {
	        "class": classes$1("btn", "btn-now"),
	        "onClick": handleCancel
	      }, ["\u73B0\u5728"]), vue.createVNode("button", {
	        "class": classes$1("btn", "btn-confirm"),
	        "onClick": handleConfirm
	      }, ["\u786E\u5B9A"])])])])]
	    }) : ""]);
	  }
	});

	withInstall(DateTimePicker);

	const {
	  g: g$2,
	  gb,
	  ge,
	  gm,
	  e: e$3,
	  classes
	} = createNamespace("date-time-range-picker");
	var DateTimeRangePicker = vue.defineComponent({
	  name: "Date-Time-Range-Picker",
	  components: {
	    ViCalendar
	  },
	  setup(props, ctx) {
	    const isPanelUp = vue.ref(true);
	    const showPanel = vue.ref(false);
	    const inputName = g$2() + "__input";
	    const panelName = g$2() + "__panel";
	    const startCalendarProps = {
	      scopeName: "." + panelName,
	      useTransition: false,
	      hasFootBtns: true,
	      usePropTime: false
	    };
	    const endCalendarProps = {
	      scopeName: "." + panelName,
	      useTransition: false,
	      hasFootBtns: true,
	      usePropTime: false
	    };
	    const startCalendarRef = vue.ref();
	    const endCalendarRef = vue.ref();
	    const fullTime = vue.ref();
	    const handleClick = (e2) => {
	      showPanel.value = !showPanel.value;
	    };
	    const handleConfirm = () => {
	      let S = startCalendarRef.value.getStore();
	      let startText = `${S.year}-${S.month}-${S.date}  ${S.hour}: ${S.minute}: ${S.second}`;
	      let E = endCalendarRef.value.getStore();
	      let endText = `${E.year}-${E.month}-${E.date}  ${E.hour}: ${E.minute}: ${E.second}`;
	      fullTime.value = `${startText}  To  ${endText}`;
	      validateRangeResult(S, E, () => {
	        showPanel.value = !showPanel.value;
	      }, () => {
	        fullTime.value = "";
	        E.year = S.year;
	        E.month = S.month;
	        E.date = S.date;
	        E.hour = S.hour;
	        E.minute = S.minute;
	        E.second = S.second;
	      });
	      showPanel.value = false;
	    };
	    const handleCancel = () => {
	      fullTime.value = "";
	    };
	    return () => vue.createVNode("div", {
	      "class": classes(g$2())
	    }, [vue.createVNode("div", {
	      "class": classes(inputName)
	    }, [vue.createVNode("input", {
	      "type": "text",
	      "value": fullTime.value,
	      "onClick": handleClick
	    }, null)]), vue.createVNode(vue.Transition, {
	      "name": "scale"
	    }, {
	      default: () => [showPanel.value ? vue.createVNode("div", {
	        "class": classes(panelName, [isPanelUp.value, "float-up", "float-down"])
	      }, [vue.createVNode(vue.resolveComponent("vi-calendar"), vue.mergeProps(startCalendarProps, {
	        "ref": startCalendarRef
	      }), null), vue.createVNode(vue.resolveComponent("vi-calendar"), vue.mergeProps(endCalendarProps, {
	        "ref": endCalendarRef
	      }), null), vue.createVNode("div", {
	        "class": classes("vi-panel__footer")
	      }, [vue.createVNode("button", {
	        "class": "clear",
	        "onClick": handleCancel
	      }, [vue.createTextVNode("\u6E05\u9664")]), vue.createVNode("button", {
	        "class": "confirm",
	        "onClick": handleConfirm
	      }, [vue.createTextVNode("\u786E\u5B9A")])])]) : ""]
	    })]);
	  }
	});

	withInstall(DateTimeRangePicker);

	class t$1 {
	  constructor() {
	    this.__map = {};
	  }
	  beforeEach(t2) {
	    this.__interceptor = t2;
	  }
	  on(t2, i) {
	    const s = Array.isArray(t2) ? t2 : [t2];
	    for (const t3 of s) {
	      this.__map[t3] = this.__map[t3] || [];
	      const s2 = this.__map[t3];
	      s2 && s2.push(i);
	    }
	    return this;
	  }
	  emit(t2, i, s) {
	    void 0 !== this.__interceptor ? this.__interceptor(t2, () => {
	      this.__emit(t2, i), s && s();
	    }) : (this.__emit(t2, i), s && s());
	  }
	  __emit(t2, i) {
	    const s = this.__map[t2];
	    if (Array.isArray(s) && (null == s ? void 0 : s.length))
	      for (const _ of s)
	        _(i, t2);
	    this.event = i;
	  }
	  off(t2, i) {
	    const s = this.__map[t2];
	    if (void 0 !== s)
	      if (void 0 === i)
	        delete this.__map[t2];
	      else {
	        const t3 = s.findIndex((t4) => t4 === i);
	        s.splice(t3, 1);
	      }
	  }
	  destroy() {
	    this.__map = {};
	  }
	}

	const n$1 = "clientX", e$2 = "clientY", t = 16, c$3 = "start", o$1 = "move", s$1 = "cancel", u$3 = "end", a$2 = "left", i$3 = "right", r$4 = "up", d$1 = "down", m$2 = { 4: "start", 5: "move", 1: "end", 3: "cancel" };
	function v$1(n2) {
	  return m$2[n2];
	}
	function b(n2, e2, t2) {
	  const c2 = { 1: { 0: { move: 4 }, 4: { move: 5, end: 1, cancel: 3 }, 5: { move: 5, end: 1, cancel: 3 } }, 0: { 4: { move: 2, end: 1, cancel: 3 }, 5: { start: 2, move: 2, end: 1, cancel: 3 } } }[Number(n2)][e2];
	  return void 0 !== c2 && c2[t2] || 0;
	}
	function g$1(n2) {
	  [1, 3, 2].includes(n2.state) && (n2.state = 0);
	}
	function h$3(n2) {
	  return [5, 1, 3].includes(n2);
	}
	function j(n2) {
	  if (n2.disabled)
	    return n2.state = 0, true;
	}
	function O(n2, e2) {
	  return Object.assign(Object.assign(Object.assign({}, n2), e2), { state: 0, disabled: false });
	}
	function p$3(n2) {
	  return Math.round(100 * n2) / 100;
	}

	function r$3() {
	  let t2, o2, i2, r2, a2 = 0;
	  return function(u2) {
	    if (t2 = o2, void 0 !== u2) {
	      a2 = Number.MAX_SAFE_INTEGER > a2 ? ++a2 : 1;
	      const h2 = function(t3, o3) {
	        const { phase: i3, points: r3, changedPoints: a3, nativeEvent: u3 } = t3, h3 = r3.length, p3 = c$3 === i3, g3 = u$3 === i3 && 0 === h3 || s$1 === i3, l2 = Date.now(), { x: d, y: m } = c$2(r3) || c$2(a3), { currentTarget: v } = u3;
	        return Object.assign(t3, { id: o3, x: d, y: m, timestamp: l2, isStart: p3, isEnd: g3, pointLength: h3, currentTarget: v, getOffset(t4 = v) {
	          const e2 = t4.getBoundingClientRect();
	          return { x: d - Math.round(e2.left), y: m - Math.round(e2.top) };
	        } });
	      }(u2, a2);
	      o2 = h2;
	      const { isStart: p2, pointLength: g2 } = h2;
	      return p2 && (i2 = h2, t2 = void 0, r2 = 1 < g2 ? h2 : void 0), Object.assign(Object.assign({}, h2), { prevInput: t2, startMultiInput: r2, startInput: i2 });
	    }
	  };
	}
	function c$2(t2) {
	  const { length: e2 } = t2;
	  if (0 < e2) {
	    if (1 === e2) {
	      const { clientX: e3, clientY: n3 } = t2[0];
	      return { x: Math.round(e3), y: Math.round(n3) };
	    }
	    const n2 = t2.reduce((t3, e3) => (t3.x += e3[n$1], t3.y += e3[e$2], t3), { x: 0, y: 0 });
	    return { x: Math.round(n2.x / e2), y: Math.round(n2.y / e2) };
	  }
	}
	function a$1(t2, e2, n2, s2) {
	  const o2 = {};
	  for (const t3 in n2)
	    ["target", "currentTarget", "type"].includes(t3) || (o2[t3] = n2[t3]);
	  let i2;
	  return document.createEvent ? (i2 = document.createEvent("HTMLEvents"), i2.initEvent(t2, null == s2 ? void 0 : s2.bubbles, null == s2 ? void 0 : s2.cancelable)) : i2 = new Event(t2, s2), Object.assign(i2, o2, { match: () => n2.targets && 0 < n2.targets.length && n2.targets.every((t3) => i2.currentTarget.contains(t3)) }), e2.dispatchEvent(i2);
	}
	function u$2(t2, e2) {
	  const { preventDefault: n2 } = e2;
	  return s2 = n2, "[object Function]" === Object.prototype.toString.call(s2) ? n2(t2) : !!n2;
	  var s2;
	}
	const h$2 = ["touchstart", "touchmove", "touchend", "touchcancel", "mousedown"], p$2 = ["mousemove", "mouseup"];
	const g = { domEvents: { bubbles: true, cancelable: true }, preventDefault: (t2) => {
	  if (t2.target && "tagName" in t2.target) {
	    const { tagName: e2 } = t2.target;
	    return !/^(?:INPUT|TEXTAREA|BUTTON|SELECT)$/.test(e2);
	  }
	  return false;
	} };
	class l$1 extends t$1 {
	  constructor(t2, e2) {
	    super(), this.v = "2.1.3", this.__computeFunctionList = [], this.__computeFunctionCreatorList = [], this.__pluginContexts = [], this.__isIgnoreMouse = false, this.el = t2, this.c = {}, this.__options = Object.assign(Object.assign({}, g), e2);
	    const n2 = function(t3) {
	      const e3 = r$3();
	      return function(n3) {
	        const s3 = [], o2 = [];
	        Array.from(n3.touches).forEach(({ clientX: e4, clientY: n4, target: i3 }) => {
	          (null == t3 ? void 0 : t3.contains(i3)) && (s3.push(i3), o2.push({ clientX: e4, clientY: n4, target: i3 }));
	        });
	        const i2 = Array.from(n3.changedTouches).map(({ clientX: t4, clientY: e4, target: n4 }) => ({ clientX: t4, clientY: e4, target: n4 }));
	        return e3({ phase: n3.type.replace("touch", ""), changedPoints: i2, points: o2, nativeEvent: n3, target: n3.target, targets: s3 });
	      };
	    }(this.el), s2 = function() {
	      let t3, e3 = false, n3 = null;
	      const s3 = r$3();
	      return function(o2) {
	        const { clientX: i2, clientY: r2, type: c2, button: a2, target: u2 } = o2;
	        let h2, p2 = [{ clientX: i2, clientY: r2, target: u2 }];
	        if ("mousedown" === c2 && 0 === a2)
	          n3 = u2, e3 = true, h2 = "start";
	        else {
	          if (!e3)
	            return;
	          "mousemove" === c2 ? h2 = "move" : "mouseup" === c2 && (p2 = [], h2 = "end", e3 = false);
	        }
	        const g2 = t3 || [{ clientX: i2, clientY: r2, target: u2 }];
	        if (t3 = [{ clientX: i2, clientY: r2, target: u2 }], void 0 !== h2)
	          return s3({ phase: h2, changedPoints: g2, points: p2, target: n3, targets: [n3], nativeEvent: o2 });
	      };
	    }();
	    if (this.__inputCreatorMap = { touchstart: n2, touchmove: n2, touchend: n2, touchcancel: n2, mousedown: s2, mousemove: s2, mouseup: s2 }, this.on("at:after", (t3) => {
	      const { target: e3, __type: n3 } = t3, { domEvents: s3 } = this.__options;
	      s3 && void 0 !== this.el && e3 && (a$1(n3, e3, t3, s3), a$1("at:after", e3, t3, s3));
	    }), void 0 !== t2) {
	      t2.style.webkitTapHighlightColor = "rgba(0,0,0,0)";
	      let e3 = false;
	      try {
	        const t3 = {};
	        Object.defineProperty(t3, "passive", { get() {
	          e3 = true;
	        } }), window.addEventListener("_", () => {
	        }, t3);
	      } catch (t3) {
	      }
	      this.on("u", function(t3, e4, n3) {
	        return h$2.forEach((s3) => {
	          t3.addEventListener(s3, e4, n3);
	        }), p$2.forEach((t4) => {
	          window.addEventListener(t4, e4, n3);
	        }), () => {
	          h$2.forEach((n4) => {
	            t3.removeEventListener(n4, e4);
	          }), p$2.forEach((t4) => {
	            window.removeEventListener(t4, e4);
	          });
	        };
	      }(t2, this.catchEvent.bind(this), false === this.__options.preventDefault && e3 ? { passive: true } : { passive: false }));
	    }
	  }
	  use(t2, e2) {
	    this.__pluginContexts.push(t2(this, e2));
	  }
	  catchEvent(t2) {
	    const e2 = this.__inputCreatorMap[t2.type](t2);
	    if (void 0 !== e2) {
	      const n2 = () => t2.stopPropagation(), s2 = () => t2.stopImmediatePropagation(), o2 = () => t2.preventDefault();
	      if (u$2(t2, this.__options))
	        o2();
	      else if ("touchstart" === t2.type ? this.__isIgnoreMouse = true : "touchmove" === t2.type && (this.__isIgnoreMouse = false), this.__isIgnoreMouse && t2.type.startsWith("mouse"))
	        return void ("mouseup" === t2.type && (this.__isIgnoreMouse = false));
	      this.emit("input", e2), this.emit2(`at:${e2.phase}`, e2, {});
	      const i2 = {};
	      this.__computeFunctionList.forEach((t3) => {
	        const n3 = t3(e2, i2);
	        if (void 0 !== n3)
	          for (const t4 in n3)
	            i2[t4] = n3[t4];
	      }), this.emit("computed", Object.assign(Object.assign(Object.assign({}, e2), i2), { stopPropagation: n2, stopImmediatePropagation: s2, preventDefault: o2 }));
	    }
	  }
	  compute(t2, e2) {
	    for (const e3 of t2)
	      this.__computeFunctionCreatorList.includes(e3) || (this.__computeFunctionCreatorList.push(e3), this.__computeFunctionList.push(e3()));
	    this.on("computed", e2);
	  }
	  beforeEach(t2) {
	    super.beforeEach((e2, n2) => {
	      var s2;
	      (null === (s2 = this.c) || void 0 === s2 ? void 0 : s2.name) ? t2(e2, n2) : n2();
	    });
	  }
	  get(t2) {
	    return this.__pluginContexts.find((e2) => t2 === e2.name);
	  }
	  set(t2) {
	    this.__options = Object.assign(Object.assign({}, this.__options), t2);
	  }
	  emit2(t2, e2, n2) {
	    this.c = n2, this.emit(t2, Object.assign(Object.assign({}, e2), { type: t2 }), () => {
	      this.emit("at:after", Object.assign(Object.assign({}, e2), { name: t2, __type: t2 }));
	    });
	  }
	  destroy() {
	    this.emit("u"), super.destroy();
	  }
	}

	var x = (r2) => Math.sqrt(r2.x * r2.x + r2.y * r2.y), y = (r2, a2) => r2.x * a2.x + r2.y * a2.y, e$1 = (r2, a2) => {
	  var t2 = x(r2) * x(a2);
	  if (0 === t2)
	    return 0;
	  var h2 = y(r2, a2) / t2;
	  return h2 > 1 && (h2 = 1), Math.acos(h2);
	}, n = (r2, a2) => r2.x * a2.y - a2.x * r2.y, o = (r2) => r2 / Math.PI * 180, s = (r2, a2) => {
	  var t2 = e$1(r2, a2);
	  return n(r2, a2) > 0 && (t2 *= -1), o(t2);
	}, u$1 = (x2, y2) => {
	  if (0 !== x2 || 0 !== y2)
	    return Math.abs(x2) >= Math.abs(y2) ? 0 < x2 ? i$3 : a$2 : 0 < y2 ? d$1 : r$4;
	};

	function p$1() {
	  let n2 = 0, e2 = 0;
	  return function(o2, r2) {
	    const { prevVecotr: i2, startVecotr: a2, activeVecotr: c2 } = r2;
	    return c2 && (e2 = Math.round(s(c2, i2)), n2 = Math.round(s(c2, a2))), { angle: n2, deltaAngle: e2 };
	  };
	}
	function d() {
	  return function(t2) {
	    const { prevInput: e2 } = t2;
	    let o2 = 0, r2 = 0, i2 = 0;
	    if (void 0 !== e2 && (o2 = t2.x - e2.x, r2 = t2.y - e2.y, 0 !== o2 || 0 !== r2)) {
	      const t3 = Math.sqrt(Math.pow(o2, 2) + Math.pow(r2, 2));
	      i2 = Math.round(o(Math.acos(Math.abs(o2) / t3)));
	    }
	    return { deltaX: o2, deltaY: r2, deltaXYAngle: i2 };
	  };
	}
	function h$1() {
	  let t2, n2 = 0, u2 = 0, s2 = 0, p2 = 0, d2 = 0;
	  return function(h2) {
	    const { phase: l2, startInput: f2 } = h2;
	    return c$3 === l2 ? (n2 = 0, u2 = 0, s2 = 0, p2 = 0, d2 = 0) : o$1 === l2 && (n2 = Math.round(h2.points[0][n$1] - f2.points[0][n$1]), u2 = Math.round(h2.points[0][e$2] - f2.points[0][e$2]), s2 = Math.abs(n2), p2 = Math.abs(u2), d2 = Math.round(x({ x: s2, y: p2 })), t2 = u$1(n2, u2)), { displacementX: n2, displacementY: u2, distanceX: s2, distanceY: p2, distance: d2, overallDirection: t2 };
	  };
	}
	function l() {
	  let t2 = 1;
	  return function(n2, o2) {
	    let r2 = 1;
	    const { prevVecotr: i2, startVecotr: a2, activeVecotr: c2 } = o2;
	    return c2 && (r2 = p$3(x(c2) / x(i2)), t2 = p$3(x(c2) / x(a2))), { scale: t2, deltaScale: r2 };
	  };
	}
	function f() {
	  let t2, n2, e2 = 0, r2 = 0, i2 = 0, a2 = 0;
	  return function(c2) {
	    if (void 0 !== c2) {
	      n2 = n2 || c2.startInput;
	      const u2 = c2.timestamp - n2.timestamp;
	      if (t < u2) {
	        const s2 = c2.x - n2.x, p2 = c2.y - n2.y;
	        i2 = Math.round(s2 / u2 * 100) / 100, a2 = Math.round(p2 / u2 * 100) / 100, e2 = Math.abs(i2), r2 = Math.abs(a2), t2 = u$1(s2, p2), n2 = c2;
	      }
	    }
	    return { velocityX: e2, velocityY: r2, speedX: i2, speedY: a2, direction: t2 };
	  };
	}
	function M() {
	  let t2 = 0;
	  return function(n2) {
	    const { phase: e2 } = n2;
	    return c$3 === e2 && (t2 = n2.pointLength), { maxPointLength: t2 };
	  };
	}
	function v(t2) {
	  return { x: t2.points[1][n$1] - t2.points[0][n$1], y: t2.points[1][e$2] - t2.points[0][e$2] };
	}
	function m$1() {
	  let t2, n2, e2;
	  return function(o2) {
	    const { prevInput: r2, startMultiInput: i2 } = o2;
	    return void 0 !== i2 && void 0 !== r2 && o2.id !== i2.id && 1 < r2.pointLength && 1 < o2.pointLength ? (t2 = v(i2), n2 = v(r2), e2 = v(o2)) : e2 = void 0, { startVecotr: t2, prevVecotr: n2, activeVecotr: e2 };
	  };
	}

	const m = { name: "tap", pointLength: 1, tapTimes: 1, waitNextTapTime: 300, maxDistance: 2, maxDistanceFromPrevTap: 9, maxPressTime: 250 };
	function r$2(r2, s) {
	  const c = O(m, s);
	  let p, u, x$1, T = 0;
	  function f() {
	    T = 0, p = void 0, u = void 0;
	  }
	  return r2.compute([h$1, M], (t2) => {
	    if (j(c))
	      return;
	    const { phase: i2, x: o2, y: m2 } = t2;
	    u$3 === i2 && (c.state = 0, !function() {
	      const { startInput: e2, pointLength: n2, timestamp: a2 } = t2, i3 = a2 - e2.timestamp, { distance: o3, maxPointLength: m3 } = t2;
	      return m3 === c.pointLength && 0 === n2 && c.maxDistance >= o3 && c.maxPressTime > i3;
	    }() ? (f(), c.state = 2) : (clearTimeout(x$1), function(t3, e2) {
	      if (void 0 !== p) {
	        const n2 = x({ x: t3.x - p.x, y: t3.y - p.y });
	        return p = t3, e2.maxDistanceFromPrevTap >= n2;
	      }
	      return p = t3, true;
	    }({ x: o2, y: m2 }, c) && function(t3) {
	      const e2 = performance.now();
	      if (void 0 === u)
	        return u = e2, true;
	      {
	        const n2 = e2 - u;
	        return u = e2, n2 < t3;
	      }
	    }(c.waitNextTapTime) ? T++ : T = 1, 0 == T % c.tapTimes ? (c.state = 1, r2.emit2(c.name, t2, c), f()) : x$1 = setTimeout(() => {
	      c.state = 2, f();
	    }, c.waitNextTapTime)));
	  }), c;
	}

	const p = { name: "pan", threshold: 10, pointLength: 1 };
	function u(u2, d$1) {
	  const f$1 = O(p, d$1);
	  return u2.compute([f, h$1, d], (t2) => {
	    if (g$1(f$1), j(f$1))
	      return;
	    const c2 = function() {
	      const { pointLength: e2, distance: n2 } = t2;
	      return f$1.pointLength === e2 && f$1.threshold <= n2;
	    }();
	    if (f$1.state = b(c2, f$1.state, t2.phase), c2 || h$3(f$1.state)) {
	      const { name: e2 } = f$1;
	      u2.emit2(e2, t2, f$1), u2.emit2(e2 + v$1(f$1.state), t2, f$1), ![u$3, s$1].includes(t2.phase) && t2.direction && u2.emit2(e2 + t2.direction, t2, f$1);
	    }
	  }), f$1;
	}

	const c$1 = { name: "swipe", threshold: 10, velocity: 0.3, pointLength: 1 };
	function a(a2, r) {
	  const s = O(c$1, r);
	  return a2.compute([h$1, f, M], (t2) => {
	    if (s.state = 0, !s.disabled && function() {
	      if (u$3 !== t2.phase)
	        return false;
	      const { velocityX: o2, velocityY: n2, distance: i2, maxPointLength: c2 } = t2;
	      return c2 === s.pointLength && 0 === t2.points.length && s.threshold < i2 && s.velocity < Math.max(o2, n2);
	    }()) {
	      const { name: e2 } = s;
	      s.state = 1, a2.emit2(e2, t2, s), a2.emit2(e2 + t2.direction, t2, s);
	    }
	  }), s;
	}

	const r$1 = { name: "press", pointLength: 1, maxDistance: 9, minPressTime: 251 };
	function c(c2, u) {
	  const p = O(r$1, u);
	  let f = 0;
	  return c2.compute([h$1], (t2) => {
	    if (j(p))
	      return;
	    const { phase: o2, startInput: r2, pointLength: u2 } = t2;
	    if (c$3 === o2 && p.pointLength === u2)
	      g$1(p), clearTimeout(f), f = setTimeout(() => {
	        p.state = 1, c2.emit2(p.name, t2, p);
	      }, p.minPressTime);
	    else if (u$3 === o2 && 1 === p.state)
	      c2.emit2(`${p.name}${r$4}`, t2, p);
	    else if (1 !== p.state) {
	      const e2 = t2.timestamp - r2.timestamp;
	      (!function() {
	        const { distance: e3 } = t2;
	        return e3 && p.maxDistance > e3;
	      }() || p.minPressTime > e2 && [u$3, s$1].includes(o2)) && (clearTimeout(f), p.state = 2);
	    }
	  }), p;
	}

	const i$2 = { name: "pinch", threshold: 0, pointLength: 2 };
	function r(r2, m) {
	  const p = O(i$2, m);
	  return r2.compute([m$1, l], (t2) => {
	    if (g$1(p), j(p))
	      return;
	    const c2 = function() {
	      const { pointLength: e2, scale: n2, deltaScale: o2, phase: a2 } = t2;
	      return p.pointLength === e2 && p.threshold < Math.abs(n2 - 1);
	    }();
	    p.state = b(c2, p.state, t2.phase);
	    const { name: h2 } = p;
	    if (c2 || h$3(p.state)) {
	      r2.emit2(h2, t2, p);
	      const { deltaScale: e2 } = t2;
	      1 !== e2 && r2.emit2(h2 + (1 < e2 ? "in" : "out"), t2, p);
	    }
	    const i2 = v$1(p.state);
	    i2 && r2.emit2(h2 + i2, t2, p);
	  }), p;
	}

	const h = { name: "rotate", threshold: 0, pointLength: 2 };
	function i$1(i2, m) {
	  const u = O(h, m);
	  return i2.compute([m$1, p$1], (t2) => {
	    if (j(u))
	      return;
	    g$1(u);
	    const r2 = function() {
	      const { pointLength: e2, angle: n2 } = t2;
	      return u.pointLength === e2 && u.threshold < Math.abs(n2);
	    }();
	    u.state = b(r2, u.state, t2.phase);
	    const { name: c2 } = u;
	    (r2 || h$3(u.state)) && i2.emit2(c2, t2, u);
	    const h2 = v$1(u.state);
	    h2 && i2.emit2(c2 + h2, t2, u);
	  }), u;
	}

	function e(e2) {
	  e2.use(r$2, { name: "doubletap", tapTimes: 2 });
	  const a = e2.get("doubletap");
	  let o;
	  return e2.beforeEach((t2, e3) => {
	    "tap" === t2 ? (clearTimeout(o), o = setTimeout(() => {
	      [0, 2].includes(a.state) && e3();
	    }, 300)) : e3();
	  }), a;
	}

	class i extends l$1 {
	  constructor(t2, u2) {
	    super(t2, u2), this.use(r$2), this.use(u), this.use(a), this.use(c), this.use(r), this.use(i$1);
	  }
	}
	i.STATE_POSSIBLE = 0, i.STATE_START = 4, i.STATE_MOVE = 5, i.STATE_END = 1, i.STATE_CANCELLED = 3, i.STATE_FAILED = 2, i.STATE_RECOGNIZED = 1, i.tap = r$2, i.pan = u, i.swipe = a, i.press = c, i.rotate = i$1, i.pinch = r, i.doubletap = e;

	const getCurrentTranslate = (el) => {
	  const style = window.getComputedStyle(el, null);
	  const { transform } = style;
	  const array = transform.match(/(\-?)(\d)+(\.\d{0,})?/g);
	  if (!array) {
	    return {
	      x: 0,
	      y: 0
	    };
	  }
	  return { x: Math.round(array[4]), y: Math.round(array[5]) };
	};
	const Touch = {
	  mounted(el, binding) {
	    var _a;
	    if (!el) {
	      return false;
	    }
	    const style = window.getComputedStyle(el, null);
	    el._touch = {
	      ...(_a = binding.value) != null ? _a : {}
	    };
	    const totalWidth = parseInt(style.width);
	    el.style.width = `${totalWidth}px`;
	    if (el.parentNode) {
	      el.parentNode["offsetWidth"];
	    }
	    const at = new i(el);
	    at.on("panmove", (e) => {
	      el.style.transitionDuration = "0ms";
	      const { x, y } = getCurrentTranslate(el);
	      const moveDistanceX = x + e.deltaX;
	      el.style.transform = `translate(${moveDistanceX}px, 0px)`;
	      if (e.direction == "right") ;
	      if (e.direction == "left") ;
	    });
	    at.on("panend", (e) => {
	      return false;
	    });
	    at.on("swipe", (ev) => {
	      return false;
	    });
	    at.on("press", (e) => {
	      var _a2;
	      console.log(e, "\u6309\u538B", (_a2 = el._touch) == null ? void 0 : _a2.press);
	    });
	    at.on("pressup", (e) => {
	      console.log(e, "\u677E\u5F00");
	    });
	    at.on("tap", (e) => {
	      console.log("\u70B9\u51FB");
	    });
	  },
	  install(app) {
	    app.directive("touch", this);
	  }
	};

	const getPosition = function(t) {
	  const e = this.getBoundingClientRect(), n = Math.max(e.width, e.height);
	  return {
	    range: n,
	    x: t.clientX - e.left - n / 2,
	    y: t.clientY - e.top - n / 2
	  };
	};
	const Ripple = {
	  mounted(el, binding) {
	    var _a;
	    el._ripple = {
	      ...(_a = binding.value) != null ? _a : {}
	    };
	    el.addEventListener(
	      "click",
	      function(n) {
	        const _ripple = el._ripple;
	        if (_ripple.disabled) {
	          return;
	        }
	        n.stopPropagation();
	        const i = getPosition.call(this, n), o = document.createElement("span");
	        o.className = "ripple", o.style.top = i.y + "px", o.style.left = i.x + "px", o.style.width = i.range + "px", o.style.height = i.range + "px", o.style.animationDuration = "1.2s", o.style.background = "#00afef", o.style.opacity = ".1", o.addEventListener(
	          "animationend",
	          function() {
	            const dom = this.parentNode;
	            dom.removeChild(this);
	          },
	          false
	        ), this.appendChild(o);
	      },
	      { passive: true }
	    );
	  },
	  updated(el, binding) {
	    var _a;
	    el._ripple = {
	      ...el._ripple,
	      ...(_a = binding.value) != null ? _a : {},
	      tasker: null
	    };
	  },
	  install(app) {
	    app.directive("ripple", this);
	  }
	};

	exports.VICol = VICol;
	exports.VIRow = VIRow;
	exports["default"] = installer;
	exports.makeInstaller = makeInstaller;
	exports.ripple = Ripple;
	exports.touch = Touch;

	Object.defineProperty(exports, '__esModule', { value: true });

}));
